/**
** Byronus open source project
** Distributed under the BSD license
** Pure C99 gcc/Win32 text mode 4k-Intro 
** Copyleft (c) 2003-2009 Alexandre Buge
*/
#include <windows.h>

enum {CONSOLE_LINE_COUNT    = 25};  /** in characters */
enum {CONSOLE_COL_COUNT     = 80};  /** in characters */
enum {WATER_DEEP            = 10};  /** in characters */
enum {DEMO_SPEED_FACTOR     = 30};  /** in frames per millisecond */

static LPCSTR g_the_sexiest_logo[CONSOLE_LINE_COUNT] = {
"        .--.",
"     .-////////.        -/=/",
"    //-////:///##      ##////",
"  -/----..--,--///    .#/::://",
"            .//        //:/---/,",
" .         ---          //--,,//",
" .     .-,               //--..--",
" --   --       /##X#X###- //-.  ..",
"  /-.--     ,#M######X#@###/-    .",
"  //-/     #########H@@#####/    -",
"   ///    #X#####X#@@@@@#####/   ,",
"     -/   #XXXX##X#@@@@@##@@##-  -",
"      /#  #####H#X#@@@#@@@@@##-.//",
"       /#:/#####H##H@@@@@@@##//#/",
"           .##,############",
"             //./######/-",
"",
"   :#X$$%#, %#            X#######@",
" /#/     ##,##  @@##   =%:##    .$#: :M###/. .#####-. ,#####  M#####/",
" /##/--//  ##/@##;##  .#####    ;## ######## ####### ######## #######",
"  /##H##@# ##@#@  :#. ##=#########,############.  ##M##.  ######   ##",
";#.    ,##/%/##/   #/##. ##     ## ##//=//M ##   X#:##-   ##.##    ##",
"-##+++X##=## .###  ###/ ##,     ## #######M ####X##.######## ##   X#:",
" /#++%#:  @/   ##  ###  ##     :##  #####:  -#####   X####;  #X   @#",
"                 /###",
};


static CONST DWORD g_sinus_table[CONSOLE_LINE_COUNT] = 
{/* sin(PI / (double)CONSOLE_LINE_COUNT * (double)i) * 8.0) + 4.0 */
    4,  5,  5,  6,  7,  8,  9,  10, 10, 11, 
    11, 11, 11, 11, 11, 11, 10, 10, 9,  8,  
    7,  6,  5,  5 , 4
}; /** bye bye libm and speed, hello .data space waste */


/** bye bye libc */
void* _alloca(size_t size)
{
    size = size; /* unused */
    return NULL;
}

/** bye bye libc */
static DWORD strlen_world_s_ugliest_implementation(LPCSTR lpStr)
{
    DWORD dwLenght = 0;
    while(lpStr[dwLenght]) /** as you can see, speed is useless ;-) */
        ++dwLenght;
    return dwLenght;
}


/** gcc bootstrap */
void mainCRTStartup()
{
    DWORD           x, y, dwLenght, dwOffset, dwUncheckedValueNoMurphyLawsInDemoScene;
    COORD           Coord;
    CHAR            lpBlankLine[CONSOLE_COL_COUNT];
    CONST WORD      wAttrOldFashion                 = FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE;
    CONST WORD      wAttrSubMarine                  = BACKGROUND_BLUE | FOREGROUND_GREEN;
    CONST HANDLE    hStdOutput                      = GetStdHandle(STD_OUTPUT_HANDLE);
    
    Coord.X = CONSOLE_COL_COUNT;
    Coord.Y = CONSOLE_LINE_COUNT; /** don't manage returned error case for WINAPI functions, space is precious, sorry for that */
    SetConsoleScreenBufferSize(hStdOutput, Coord);
    for(y = 0; y < CONSOLE_COL_COUNT; ++y)
        lpBlankLine[y] = ' ';
    x = 0;
    for(;;) /** Ctrl+break is your friend here, sorry again */
    {
      for(y = 0; y < CONSOLE_LINE_COUNT; ++y)
      {
        dwOffset = g_sinus_table[(x + y) % CONSOLE_LINE_COUNT];
        Coord.Y = (SHORT)y;
        for(dwLenght = 0; dwLenght < CONSOLE_COL_COUNT; ++dwLenght) 
        {
            Coord.X = (SHORT)dwLenght;
            WriteConsoleOutputAttribute(hStdOutput, ((dwLenght + dwOffset + WATER_DEEP) < CONSOLE_COL_COUNT) ? &wAttrOldFashion : &wAttrSubMarine, 
                1, Coord, &dwUncheckedValueNoMurphyLawsInDemoScene); /** paint water here */
        }
        dwLenght = strlen_world_s_ugliest_implementation(g_the_sexiest_logo[y]);
        Coord.X = 0; /** paint logo now */
        WriteConsoleOutputCharacterA(hStdOutput, lpBlankLine, dwOffset, Coord, &dwUncheckedValueNoMurphyLawsInDemoScene);
        Coord.X = (SHORT)dwOffset;
        WriteConsoleOutputCharacterA(hStdOutput, g_the_sexiest_logo[y], dwLenght, Coord, &dwUncheckedValueNoMurphyLawsInDemoScene);
        Coord.X = (SHORT)(dwLenght + dwOffset + 1);
        WriteConsoleOutputCharacterA(hStdOutput, lpBlankLine, CONSOLE_COL_COUNT - (DWORD)(Coord.X), Coord, 
            &dwUncheckedValueNoMurphyLawsInDemoScene);
      }
      ++x;
      Sleep(DEMO_SPEED_FACTOR); /** yeah mixing drawing and computing thread are not very cleaver */
    }
}
